import { Router } from 'express';
import axios from 'axios';
import { CONSTANTS_BT, TEXT_CONSTANTS } from '../constants';
import { Ticker, PayType, OrderStatus, User } from '../models_nosql';
import { getSignature_BT } from '../utilities';
import {
	handlerTotalBalance,
	getMerchantOrders,
	getUserPayMethods,
	getMerchantAdvs,
	getArraySortedByProp,
	getArrayFilteredByProp,
	getOrderDetails,
	getTickerPriceUSDT,
	checkOrderInDB,
	insertOrderToDB,
	getP2POrders,
	getSpotOrders,
	getP2POrdersNomalized,
	getMerchantAdvsNomalized,
	getMerchantOrdersNomalized,
	getSpotOrdersNomalized,
	getBalancesNormalized,
	getPayMethodProps,
	getPayMethodPropsReverse,
	getPaySubAccount,
	getSingleUserProperty,
	consoleProcessed,
	getOrderDetailsNomalized,
	getObjectRequestParams,
	getListSymbols,
} from '../common';
const {
	SHORT_NAME,
	GET_SPOT_BALANCE,
	GET_P2P_BALANCE,
	GET_FUT_BALANCE,
	GET_EARN_BALANCE,
	TRANSFER_ASSET_FROM_P2P,
	TRANSFER_ASSET_FROM_SPOT,
	GET_P2P_ORDERS,
	GET_MERCHANT_ORDERS,
	GET_MERCHANT_ORDER_DETAILS,
	GET_MERCHANT_ADVS,
	CHANGE_STATUS_ADVS,
	GET_ADV_DETAIL,
	UPDATE_DETAILS_ADV,
	GET_HISTORY_SPOT_ORDERS,
	GET_HISTORY_SPOT_ORDERS_BY_API,
	GET_ACTIVE_SPOT_ORDERS,
	GET_ACTIVE_SPOT_ORDERS_BY_API,
	GET_MERCHANT_ADV_PAYMENTS,
	GET_MERCHANT_DETAILS,
} = CONSTANTS_BT;

export const ordersRouter_BT = Router();

// получение балансов
ordersRouter_BT.post('/get-balances', async (req, res) => {
	const { userId, exchangeId, shortName } = req.body;
	const user = await User.findOne({ _id: userId });

	const objParams = {
		userId,
		shortName,
		prefix: `balance_${shortName}`,
		constants: CONSTANTS_BT,
		apiKeys: getSingleUserProperty('apiKeys', exchangeId, user.properties),
		requestHeader: getSingleUserProperty(
			'requestHeader',
			exchangeId,
			user.properties
		),
		additionals: {},
	};

	const totalBalance = await handlerTotalBalance(objParams);

	return res.status(200).json({
		success:
			totalBalance.spotBalance.length === 0 ||
			totalBalance.p2pBalance.length === 0
				? false
				: true,
		balances: totalBalance,
		message:
			totalBalance.spotBalance.length === 0 ||
			totalBalance.p2pBalance.length === 0
				? `${shortName}: ${TEXT_CONSTANTS.BALANCE_ER}`
				: `${shortName}: ${TEXT_CONSTANTS.BALANCE_OK}`,
	});
});

// получение массива объявлений
ordersRouter_BT.post('/merchant-advs', async (req, res) => {
	const { userId, shortName, exchangeId, objParams } = req.body;
	const user = await User.findOne({ _id: userId });
	const requestHeader = getSingleUserProperty(
		'requestHeader',
		exchangeId,
		user.properties
	);

	const params = {
		userId,
		prefix: shortName,
		config: {
			withCredentials: true,
			method: GET_MERCHANT_ADVS.method,
			url: GET_MERCHANT_ADVS.url,
			// url: `${GET_MERCHANT_ADVS.url}?page=1&size=15&status=2`,
			// data: null,
			data: { page: '1', size: '10', status: '2' },
			headers: {
				'Access-Control-Allow-Origin': '*',
				'accept-encoding': 'gzip, deflate, br',
				'user-agent': 'PostmanRuntime/7.29.0',
				cookie: requestHeader.cookie,
				usertoken: requestHeader.usertoken,
			},
		},
	};

	const arrData = await getMerchantAdvs(params);
	const arrPayTypes = await PayType.find();

	return res.status(200).json({
		success: arrData.length !== 0 ? true : false,
		data: {
			// merchantAdvs: [],
			merchantAdvs:
				arrData.length !== 0
					? getMerchantAdvsNomalized(
							arrData,
							{
								userId,
								exchangeId,
								prefix: shortName,
							},
							arrPayTypes
					  )
					: [],
			userPayMethods: [],
		},
		message:
			arrData.length !== 0
				? `${shortName}: ${TEXT_CONSTANTS.USER_ADVS_OK}`
				: `${shortName}: ${TEXT_CONSTANTS.USER_ADVS_ER}`,
	});
});

// изменение статуса объявления (-ий) мерчанта
ordersRouter_BT.post('/adv-status', async (req, res) => {
	res.status(400).json({
		error,
		message: `${SHORT_NAME}: ${TEXT_CONSTANTS.ADV_STATUS_ER}`,
	});
});

// получение редактируемого объявления мерчанта
ordersRouter_BT.post('/adv-edit', async (req, res) => {
	res.status(400).json({
		error,
		message: `${SHORT_NAME}: ${TEXT_CONSTANTS.ADV_EDIT_ER}`,
	});
});

// обновление редактируемого объявления
ordersRouter_BT.post('/adv-update', async (req, res) => {
	res.status(400).json({
		message: `${SHORT_NAME}: ${TEXT_CONSTANTS.ADV_UPDATE_ER}`,
	});
});

// получение массива p2p-ордеров стакана
ordersRouter_BT.post('/p2p', async (req, res) => {
	const { userId, exchangeId, shortName, objParams } = req.body;
	const {
		asset,
		fiat,
		arrPayments,
		sideType,
		rows,
		page,
		amount,
	} = objParams;

	const arrPayTypes = await PayType.find();
	const tradeType = sideType === 'BUY' ? 1 : 0;
	const paymentIdx =
		arrPayments.length === 0
			? ['']
			: arrPayments.map((item, index) => {
					return getPayMethodPropsReverse(
						exchangeId,
						'payId', // payId or payName
						item, // internalPayMethod
						arrPayTypes
					);
			  });
	const user = await User.findOne({ _id: userId });
	const requestHeaderBT = getSingleUserProperty(
		'requestHeader',
		exchangeId,
		user.properties
	);

	const params = {
		userId,
		prefix: shortName,
		config: {
			// withCredentials: true,
			method: GET_P2P_ORDERS.method,
			url: ``,
			data: null,
			headers: {
				'Access-Control-Allow-Origin': '*',
				'accept-encoding': 'gzip, deflate, br',
				'user-agent': 'PostmanRuntime/7.29.0',
				cookie: requestHeaderBT.cookie,
			},
		},
	};

	const uid = userId === '6086427c72453019ec72dbb3' ? '22032765' : '';
	let arrData = [];
	for (let i = 0; i < paymentIdx.length; i++) {
		const strURL = `userId=${uid}&tokenId=${asset}&currencyId=${fiat}&payment=${paymentIdx[i]}&side=${tradeType}&size=${rows}&page=${page}&amount=${amount}`;
		params.config.url = `${GET_P2P_ORDERS.url}?${strURL}`;
		const result = await getP2POrders(params);
		arrData = arrData.concat(result);
	}

	// отсекаем дубли
	const arrUniqueData = getArrayFilteredByProp(arrData, 'id');
	// сортировка DESC or ASC
	const arrDataSorted = getArraySortedByProp(
		shortName,
		arrUniqueData,
		tradeType
	);

	return res.status(200).json({
		success: arrData.length !== 0 ? true : false,
		data: {
			// p2pOrders: [],
			p2pOrders:
				arrData.length !== 0
					? getP2POrdersNomalized(
							arrDataSorted,
							{
								userId,
								exchangeId,
								prefix: shortName,
							},
							arrPayTypes
					  )
					: [],
			tickers: await Ticker.find(),
		},
		message:
			arrData.length !== 0
				? `${shortName}: ${arrData.length} ${TEXT_CONSTANTS.P2P_ORDERS_OK}`
				: `${shortName}: ${TEXT_CONSTANTS.P2P_ORDERS_ER}`,
	});
});

// получение массива текущих merchant-ордеров
ordersRouter_BT.post('/merchant-orders', async (req, res) => {
	const { userId, exchangeId, shortName, objParams } = req.body;
	const { page, rows, tokens } = objParams;

	const user = await User.findOne({ _id: userId });

	const params = {
		userId,
		shortName,
		// prefix: `otc_${shortName}`,
		prefix: `otc_${shortName}_all`,
		constants: CONSTANTS_BT,
		// apiKeys: getSingleUserProperty('apiKeys', exchangeId, user.properties),
		requestHeader: getSingleUserProperty(
			'requestHeader',
			exchangeId,
			user.properties
		),
		additionals: {},
	};

	const pages = 2
	let arr = []
	for(let i=1; i<pages; i++){
		params.additionals.page = i
		const objReqParams = getObjectRequestParams(params);
		const orders = await getMerchantOrders(objReqParams);
		arr = arr.concat(orders)
	}
	// console.log(arr[3])
	const arrData = arr.filter((item)=>{
		if(item.status===40) console.log(item.buyerRealName)
		return item.status===40
		// return item.currencyId==="KZT" && item.status===40
		// return item
	})
	// const objReqParams = getObjectRequestParams(params);
	// const arrData = await getMerchantOrders(objReqParams);
	const arrPayTypes = await PayType.find();
	const arrOrderStatus = await OrderStatus.find();

	return res.status(200).json({
		success: arrData.length !== 0 ? true : false,
		// data: [],
		data:
			arrData.length !== 0
				? getMerchantOrdersNomalized(
						getArraySortedByProp(shortName, arrData, 'createDate'),
						{
							userId,
							exchangeId,
							prefix: shortName,
						},
						arrPayTypes,
						arrOrderStatus
				  )
				: [],
		message:
			arrData.length !== 0
				? `${shortName}: ${arrData.length} ${TEXT_CONSTANTS.USER_ORDERS_OK}`
				: `${shortName}: ${TEXT_CONSTANTS.USER_ORDERS_ER}`,
	});
});

// получение сведений об мерчанте и его объявлениях по id
ordersRouter_BT.get('/merchant-details/:id', async (req, res) => {
	const merchantId = req.params.id;
	const axiosRequestConfig = {
		method: GET_MERCHANT_DETAILS.method,
		url: `${GET_MERCHANT_DETAILS.url}?userNo=${merchantId}`,
		data: null,
		headers: null,
	};
	await axios(axiosRequestConfig)
		.then((response) => {
			// console.log(response.data)
			return res.status(200).json({
				success: true,
				data: response.data.data,
				message: `${SHORT_NAME}: ${TEXT_CONSTANTS.USER_DETAILS_OK}`,
			});
		})
		.catch((error) => {
			res.status(400).json({
				error,
				message: `${SHORT_NAME}: ${TEXT_CONSTANTS.USER_DETAILS_ER}`,
			});
		});
});

// сохранение данных об merchant-ордере в БД по id
ordersRouter_BT.post('/save-user-orders', async (req, res) => {
	const { userId, orders, typeOrder, shortName, exchangeId } = req.body;
	const user = await User.findOne({ _id: userId });
	const arrTickers = await Ticker.find(); // тикеры и цены из БД
	const arrPayTypes = await PayType.find(); // типы оплаты из БД
	let countOrder = 0;

	const requestHeaderBT = getSingleUserProperty(
		'requestHeader',
		exchangeId,
		user.properties
	);

	const headers = {
		'Access-Control-Allow-Origin': '*',
		// 'accept-encoding': 'gzip, deflate, br',
		accept: 'application/json',
		// 'user-agent': 'PostmanRuntime/7.29.0',
		// 'user-agent':requestHeaderBT.userAgent,
		cookie: requestHeaderBT.cookie,
	};

	// проверка наличия ордера в БД
	for (let i = 0; i < orders.length; i++) {
		if (orders[i] !== null) {
			const result = await checkOrderInDB(
				userId,
				typeOrder,
				orders[i],
				shortName
			);

			// Если ордера нет в БД
			if (result.isUnique) {
				const config = {
					method: GET_MERCHANT_ORDER_DETAILS.method,
					// url: `${GET_MERCHANT_ORDER_DETAILS.url}?orderId=${orders[i]}`,
					url: GET_MERCHANT_ORDER_DETAILS.url,
					data: { orderId: orders[i] },
					headers,
				};

				// получение данных об ордере с биржи
				const orderDetails = await getOrderDetails(
					config,
					shortName,
					typeOrder
				);

				const params = {
					userId,
					shortName,
					exchangeId,
					arrTickers,
					arrPayTypes,
					orderDetails,
				};

				// если статус ордера "Completed" вставляем в БД
				const newOrder =
					orderDetails.status === 50
						? getOrderDetailsNomalized(params)
						: {};
				// если newOrder не пустой объект - сохраняем в БД
				if (Object.keys(newOrder).length !== 0) {
					await insertOrderToDB(typeOrder, newOrder);
					// console.log(
					// 	`${countOrder} | Number: ${newOrder.orderId} | payMethodName: ${newOrder.payMethodName}`
					// );
					++countOrder;
				}
			}
		}
	}

	// log print
	consoleProcessed(userId, shortName, orders, countOrder, typeOrder);

	return res.status(200).json({
		success: true,
		message: `${shortName}: ${countOrder} inserted`,
	});
});

// получение массива активных spot-ордеров
ordersRouter_BT.post('/spot-orders-active', async (req, res) => {
	const { userId, exchange, exchangeId } = req.body;
	const arrTickers = await Ticker.find();
	let status = 200;

	const user = await User.findOne({ _id: userId });
	const requestHeader = getSingleUserProperty(
		'requestHeader',
		exchange,
		user.properties
	);
	const apiKeys = getSingleUserProperty(
		'apiKeys',
		exchange,
		user.properties
	);

	// проверям существуют ли куки на этом сервисе
	if (requestHeader.userAgent === '') {
		return res.status(status).json({
			success: true,
			message: `${SHORT_NAME}: requestHeader is empty`,
			spotOrders: [],
			tickers: await Ticker.find(),
		});
	}

	const objParams = {
		userId,
		prefix: `active_${shortName}`,
		// prefix: `active_${shortName}_API`,
		apiKeys,
		requestHeader,
		constants: CONSTANTS_BT,
		additionals: {},
	};

	const objReqParams = getObjectRequestParams(objParams);
	const arrActiveSpots = await getSpotOrders(objReqParams);

	return res.status(status).json({
		success: arrActiveSpots.length === 0 ? false : true,
		message:
			arrActiveSpots.length === 0
				? `${SHORT_NAME}: ${TEXT_CONSTANTS.SPOT_ORDERS_ER}`
				: `${SHORT_NAME}: ${arrActiveSpots.length} ${TEXT_CONSTANTS.SPOT_ORDERS_OK}`,
		spotOrders:
			arrActiveSpots.length === 0
				? []
				: getSpotOrdersNomalized(
						arrActiveSpots,
						{
							userId,
							shortName: SHORT_NAME,
							exchangeId,
							flag: `active_${SHORT_NAME}`,
							// flag: `active_${SHORT_NAME}_API`,
						},
						arrTickers
				  ),
		tickers: arrTickers,
	});
});

// сохранение spot-ордеров в БД
ordersRouter_BT.post('/spot-orders-history', async (req, res) => {
	let message;
	let success = true;
	let status = 200;
	let countOrder = 0;
	const {
		userId,
		exchange,
		exchangeId,
		shortName,
		typeOrder,
		params,
	} = req.body;

	const user = await User.findOne({ _id: userId });
	const requestHeader = getSingleUserProperty(
		'requestHeader',
		exchange,
		user.properties
	);
	const apiKeys = getSingleUserProperty(
		'apiKeys',
		exchange,
		user.properties
	);

	const objParams = {
		userId,
		prefix: `history_${shortName}`,
		// prefix: `history_${shortName}_API`,
		apiKeys,
		requestHeader,
		constants: CONSTANTS_BT,
		additionals: {},
	};

	const objReqParams = getObjectRequestParams(objParams);
	const spotArray = await getSpotOrders(objReqParams);
	// const spotArray = spotArrayAPI.filter((item) => {
	// 	return item.status === 'FILLED';
	// });

	// Если ордера не получены
	if (spotArray === null || spotArray.length === 0) {
		success = false;
		message = `${shortName}: ${TEXT_CONSTANTS.SPOT_ORDERS_ER}`;
		return res.status(status).json({
			success,
			message,
		});
	}

	const arrTickers = await Ticker.find();
	const spotOrders = getSpotOrdersNomalized(
		spotArray,
		{
			userId,
			shortName,
			exchangeId,
			flag: `history_${shortName}`,
			// flag: `history_${shortName}_API`,
		},
		arrTickers
	);

	if (spotOrders.length !== 0) {
		// проверка наличия ордера в БД
		for (let i = 0; i < spotOrders.length; i++) {
			const result = await checkOrderInDB(
				spotOrders[i].userId,
				typeOrder,
				spotOrders[i].orderId,
				spotOrders[i].exchange
			);

			// Если ордера нет в БД вставляем
			if (result.isUnique) {
				// если newSpotOrder не пустой объект - сохраняем в БД
				if (Object.keys(spotOrders[i]).length !== 0) {
					await insertOrderToDB('SPOT', spotOrders[i]);
					// console.log(spotOrders[i]);
					++countOrder;
				}
			}
			// else console.log(`Order ${spotOrders[i].orderId} is not Unique`);
		}
		if (countOrder === 0) {
			success = false;
			message = `${SHORT_NAME}: ${countOrder} | ${TEXT_CONSTANTS.SPOT_ORDERS_DB_NO}`;
		} else {
			success = true;
			message = `${SHORT_NAME}: ${countOrder} | ${TEXT_CONSTANTS.SPOT_ORDERS_DB_OK}`;
		}
	} else {
		success = false;
		message = `${shortName}: ${TEXT_CONSTANTS.SPOT_ORDERS_ER}`;
	}

	// log print
	consoleProcessed(userId, shortName, spotOrders, countOrder, typeOrder);

	return res.status(status).json({
		success,
		message,
	});
});
